import React, { Component, useEffect, useRef, useState } from 'react';
import Sound from 'react-sound';
import { hot } from 'react-hot-loader';
import './App.css';

function App({ children }) {
  const player = useRef(null);

  const onPauseHandlerReactSound = () => {
    onPauseHandler('Pausing from react-sound');
  }
  const onPauseHandlerAudio = () => {
    onPauseHandler('Pausing from audio element');
  }

  const onPauseHandler = (message) => {
    fetch('http://localhost:8080/position', {
      method: 'POST',
      headers: {
        'Content-Type': 'application/json',
      },
      body: JSON.stringify({'message': message}),
    })
    .then(res => console.log('ok: ', res.ok));
  };

  useEffect(() => {
    player.current.addEventListener("pause", onPauseHandlerAudio);
  }, []);

  const [playStatus, setPlayStatus] = useState(Sound.status.PAUSED);
  const playPauseReactSound = () => {
    if (playStatus == Sound.status.PAUSED) {
      setPlayStatus(Sound.status.PLAYING);
    } else {
      setPlayStatus(Sound.status.PAUSED);
    }
  }

  return (
    <div>
      <div>
        With HTML audio element:
        &nbsp;
        <audio controls
          ref={player}
          preload="auto"
          src="http://....mp3"
          type="audio/mpeg"
        />
      </div>
      <br/>
      <div>
      With react-sound:
        <Sound
          url="http://....mp3"
          playStatus={playStatus}
          onPause={onPauseHandlerReactSound}
        />
        &nbsp;
        <button onClick={playPauseReactSound}>
          Play/Pause react-sound
        </button>
      </div>
    </div>
  );
}

export default hot(module)(App);
